// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/date-time-parser.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern Cons* WHITESPACE_CHARS;
extern Cons* TIME_DIVIDERS;
extern Cons* DATE_DIVIDERS;
extern DECLARE_STELLA_SPECIAL(oERROR_ON_MISMATCHo, boolean );
extern DECLARE_STELLA_SPECIAL(oWEEKDAY_STRINGSo, String_Hash_Table* );
extern DECLARE_STELLA_SPECIAL(oMONTH_STRINGSo, String_To_Integer_Hash_Table* );
extern DECLARE_STELLA_SPECIAL(oZONE_STRINGSo, String_Hash_Table* );
extern DECLARE_STELLA_SPECIAL(oSPECIAL_STRINGSo, String_Hash_Table* );
extern DECLARE_STELLA_SPECIAL(oSPECIAL_SYMBOLSo, Cons* );
extern DECLARE_STELLA_SPECIAL(oDATE_TIME_PATTERNSo, Cons* );

// Function signatures:
Object* hashlist_expander(Cons* list, Hash_Table* table);
void yesterday(Decoded_Date_Time* parsed_values);
void today(Decoded_Date_Time* parsed_values);
void tomorrow(Decoded_Date_Time* parsed_values);
void now(Decoded_Date_Time* parsed_values);
Symbol* am_pm(Object* string);
Symbol* noon_midn(Object* string);
Keyword* weekday(Object* thing);
Integer_Wrapper* month(Object* thing);
Float_Wrapper* zone(Object* thing);
Symbol* specialp(Object* string);
Boolean_Wrapper* secondp(Object* number);
Boolean_Wrapper* minute(Object* number);
Boolean_Wrapper* hour(Object* number);
Boolean_Wrapper* day(Object* number);
Boolean_Wrapper* year(Object* number);
Boolean_Wrapper* time_divider(Object* thecharacter);
Boolean_Wrapper* date_divider(Object* thecharacter);
Cons* match_substring(char* substring);
int digit_value(char renamed_Char);
Cons* decompose_date_time_string(char* string, int start, int end);
Cons* match_pattern_element(Symbol* pattern_element, Object* datum_element);
Cons* match_pattern(Cons* pattern, Cons* datum, int datum_length);
void deal_with_noon_midn(Object* form_value, Decoded_Date_Time* parsed_values);
void deal_with_am_pm(Object* form_value, Decoded_Date_Time* parsed_values);
void set_time_values(Cons* string_form, Decoded_Date_Time* parsed_values);
Decoded_Date_Time* parse_date_time(char* date_time_string, int start, int end, boolean error_on_mismatchP);
Calendar_Date* string_to_calendar_date(char* input);
void help_startup_date_time_parser1();
void startup_date_time_parser();

// Auxiliary global declarations:
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_FOREACH;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_ITEM;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_IN;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_CAST;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_CONS;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_OF;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_DO;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_INSERT_AT;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_FIRST;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_SECOND;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_HASHLIST;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_HASHLIST_EXPANDER;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_AM;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_PM;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_NOON;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_MIDN;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_MONTH;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_WEEKDAY;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_AM_PM;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_NOON_MIDN;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_ZONE;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_SPECIAL;
extern Keyword* KWD_DATE_TIME_PARSER_LETTER;
extern Keyword* KWD_DATE_TIME_PARSER_DIGIT;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_TIME_DIVIDER;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_DATE_DIVIDER;
extern Surrogate* SGT_DATE_TIME_PARSER_STELLA_CONS;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_SECONDP;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_MINUTE;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_HOUR;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_DAY;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_YEAR;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_STARTUP_DATE_TIME_PARSER;
extern Symbol* SYM_DATE_TIME_PARSER_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
