// idl-output.cc

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

#include "stella/stella-system.hh"

namespace stella {

DEFINE_STELLA_SPECIAL(oIDL_INDENT_CHARSo, int , 0);

void idl_output_parse_tree(Cons* constree) {
  { 
    BIND_STELLA_SPECIAL(oIDL_INDENT_CHARSo, int, 0);
    idl_output_statement(constree);
  }
}

void idl_output_statement(Object* statement) {
  if (safe_primary_type(statement) == SGT_IDL_OUTPUT_STELLA_CONS) {
    { Object* statement_000 = statement;
      Cons* statement = ((Cons*)(statement_000));

      if (statement == NIL) {
        return;
      }
      if (consP(statement->value) ||
          (!((boolean)(statement->value)))) {
        {
          idl_output_statement(statement->value);
          idl_output_statement(statement->rest);
        }
      }
      else {
        { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(statement->value));

          if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_COMMENT) {
            idl_output_comment(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_TYPEDEF) {
            idl_output_typedef(statement->rest);
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_ENUM) {
            idl_output_enum(statement->rest);
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_INTERFACE) {
            idl_output_interface(((Cons*)(statement->rest)));
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_STRUCT) {
            idl_output_struct(((Cons*)(statement->rest)));
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_DECLARATIONS) {
            idl_output_declarations(((Cons*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_IDENT) {
            idl_output_identifier(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_TYPE) {
            idl_output_type_expression(((Cons*)(statement->rest)));
          }
          else if (test_value_000 == SYM_IDL_OUTPUT_STELLA_IDL_SIGNATURES) {
            idl_output_signatures(((Cons*)(statement->rest->value)));
          }
          else {
            { Output_String_Stream* stream_000 = new_output_string_stream();

              *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
              throw *new_stella_exception(stream_000->the_string_reader());
            }
          }
        }
      }
    }
  }
  else {
    if (!((boolean)(statement))) {
      return;
    }
    idl_output_atomic_expression(statement);
  }
}

void idl_indent() {
  { int d = NULL_INTEGER;
    int iter_000 = 1;
    int upper_bound_000 = oIDL_INDENT_CHARSo.get();
    boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

    while (unboundedP_000 ||
        (iter_000 <= upper_bound_000)) {
      d = iter_000;
      iter_000 = iter_000 + 1;
      *(oCURRENT_STREAMo.get()->native_stream) << " ";
    }
  }
}

void idl_bump_indent() {
  oIDL_INDENT_CHARSo.set(oIDL_INDENT_CHARSo.get() + 2);
}

void idl_unbump_indent() {
  oIDL_INDENT_CHARSo.set(oIDL_INDENT_CHARSo.get() - 2);
}

void idl_output_typedef(Cons* renamed_Typedef) {
  *(oCURRENT_STREAMo.get()->native_stream) << "typedef " << ((String_Wrapper*)(renamed_Typedef->rest->value))->wrapper_value << " " << ((String_Wrapper*)(renamed_Typedef->value))->wrapper_value << ";" << endl << endl;
}

void idl_output_enumerands(Cons* enumerands) {
  if (((boolean)(((Cons*)(enumerands->value))))) {
    *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(((Cons*)(enumerands->value))->rest->value))->wrapper_value;
  }
  { Cons* enumerand = NULL;
    Cons* iter_000 = enumerands->rest;

    while (!(iter_000 == NIL)) {
      enumerand = ((Cons*)(iter_000->value));
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ", " << ((String_Wrapper*)(enumerand->rest->value))->wrapper_value;
    }
  }
}

void idl_output_enum(Cons* renamed_Enum) {
  *(oCURRENT_STREAMo.get()->native_stream) << "enum {";
  idl_output_enumerands(((Cons*)(((Cons*)(renamed_Enum->nth(4)))->rest->value)));
  *(oCURRENT_STREAMo.get()->native_stream) << "};" << endl << endl;
}

void idl_output_type_expression(Cons* typeexpression) {
  { String_Wrapper* typeexpr = NULL;
    Cons* iter_000 = typeexpression;

    while (!(iter_000 == NIL)) {
      typeexpr = ((String_Wrapper*)(iter_000->value));
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << typeexpr->wrapper_value << " ";
    }
  }
}

void Object::idl_output_literal() {
  { Object* object = this;

  }
}

void string_idl_output_literal(char* string) {
  *(oCURRENT_STREAMo.get()->native_stream) << "\"" << replace_substrings(replace_substrings(replace_substrings(replace_substrings(string, "\\\\", "\\"), "\\\"", make_string(1, '"')), "\\n", make_string(1, '\n')), "\\r", make_string(1, '\r')) << "\"";
}

void String_Wrapper::idl_output_literal() {
  { String_Wrapper* string = this;

    string_idl_output_literal(string->wrapper_value);
  }
}

void Mutable_String_Wrapper::idl_output_literal() {
  { Mutable_String_Wrapper* string = this;

    string_idl_output_literal((string->wrapper_value));
  }
}

void Quoted_Expression::idl_output_literal() {
  { Quoted_Expression* tree = this;

    *(oCURRENT_STREAMo.get()->native_stream) << "\"" << tree << "\"";
  }
}

void Symbol::idl_output_literal() {
  { Symbol* symbol = this;

    *(oCURRENT_STREAMo.get()->native_stream) << idl_translate_symbol_name(symbol)->wrapper_value;
  }
}

void Surrogate::idl_output_literal() {
  { Surrogate* surrogate = this;

    *(oCURRENT_STREAMo.get()->native_stream) << idl_translate_surrogate_name(surrogate)->wrapper_value;
  }
}

void Keyword::idl_output_literal() {
  { Keyword* keyword = this;

    *(oCURRENT_STREAMo.get()->native_stream) << idl_translate_keyword_name(keyword)->wrapper_value;
  }
}

void idl_output_atomic_expression(Object* atom) {
  atom->idl_output_literal();
}

void idl_output_comment(String_Wrapper* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "// " << tree->wrapper_value << endl;
}

void idl_output_identifier(String_Wrapper* identifier) {
  *(oCURRENT_STREAMo.get()->native_stream) << identifier->wrapper_value;
}

void idl_output_derived_classes(Cons* class_list) {
  if (((boolean)(((String_Wrapper*)(class_list->value))))) {
    *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(class_list->value))->wrapper_value;
  }
  { String_Wrapper* renamed_Class = NULL;
    Cons* iter_000 = class_list->rest;

    while (!(iter_000 == NIL)) {
      renamed_Class = ((String_Wrapper*)(iter_000->value));
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ", " << renamed_Class->wrapper_value;
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << " ";
}

void idl_output_template_parameters(Cons* parameters) {
  if (!(parameters == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << "template <class " << ((String_Wrapper*)(parameters->value))->wrapper_value;
    { String_Wrapper* parameter = NULL;
      Cons* iter_000 = parameters->rest;

      while (!(iter_000 == NIL)) {
        parameter = ((String_Wrapper*)(iter_000->value));
        iter_000 = iter_000->rest;
        *(oCURRENT_STREAMo.get()->native_stream) << ", class " << parameter->wrapper_value;
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << ">" << endl;
  }
}

boolean idl_output_template_classesP() {
  return (TRUE);
}

void idl_output_interface(Cons* classdef) {
  if (idl_output_template_classesP()) {
    idl_output_template_parameters(((Cons*)(classdef->rest->value)));
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "interface " << ((String_Wrapper*)(classdef->value))->wrapper_value << " ";
  if (!(((Cons*)(classdef->rest->rest->value)) == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << ": ";
    idl_output_derived_classes(((Cons*)(classdef->rest->rest->value)));
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "{" << endl;
  { Object* statement = NULL;
    Cons* iter_000 = classdef->nth_rest(4);

    while (!(iter_000 == NIL)) {
      statement = iter_000->value;
      iter_000 = iter_000->rest;
      idl_output_statement(statement);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "};" << endl << endl;
}

void idl_output_struct(Cons* classdef) {
  if (idl_output_template_classesP()) {
    idl_output_template_parameters(((Cons*)(classdef->rest->value)));
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "struct " << ((String_Wrapper*)(classdef->value))->wrapper_value << " ";
  if (!(((Cons*)(classdef->rest->rest->value)) == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << ": ";
    idl_output_derived_classes(((Cons*)(classdef->rest->rest->value)));
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "{" << endl;
  { Object* statement = NULL;
    Cons* iter_000 = classdef->nth_rest(4);

    while (!(iter_000 == NIL)) {
      statement = iter_000->value;
      iter_000 = iter_000->rest;
      idl_output_statement(statement);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "};" << endl << endl;
}

void idl_output_one_formal_parameter(Cons* parameter) {
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(parameter->value))->wrapper_value << " " << ((String_Wrapper*)(parameter->rest->value))->wrapper_value << " " << ((String_Wrapper*)(parameter->rest->rest->value))->wrapper_value;
}

void idl_output_formal_parameters(Cons* parameters) {
  { int n_parameters = parameters->length();

    *(oCURRENT_STREAMo.get()->native_stream) << "(";
    { Cons* parameter = NULL;
      int n = NULL_INTEGER;
      Cons* iter_000 = parameters;
      int iter_001 = 1;
      int upper_bound_000 = n_parameters;
      boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

      while ((!(iter_000 == NIL)) &&
          (unboundedP_000 ||
           (iter_001 <= upper_bound_000))) {
        parameter = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        n = iter_001;
        iter_001 = iter_001 + 1;
        if (n == n_parameters) {
          if (parameter->value == SYM_IDL_OUTPUT_STELLA_IDL_VAR_ARGS) {
            {
              *(oCURRENT_STREAMo.get()->native_stream) << "int ";
              *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(parameter->rest->value))->wrapper_value;
              *(oCURRENT_STREAMo.get()->native_stream) << ", ...";
            }
          }
          else {
            idl_output_one_formal_parameter(parameter);
          }
        }
        else {
          {
            idl_output_one_formal_parameter(parameter);
            *(oCURRENT_STREAMo.get()->native_stream) << ", ";
          }
        }
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

void idl_output_function_signature(Cons* function) {
  idl_output_type_expression(((Cons*)(function->value)));
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(function->rest->value))->wrapper_value;
  idl_output_formal_parameters(((Cons*)(function->rest->rest->value)));
}

void idl_output_declarations(Cons* declarations) {
  idl_bump_indent();
  { Cons* declaration = NULL;
    Cons* iter_000 = declarations;

    while (!(iter_000 == NIL)) {
      declaration = ((Cons*)(iter_000->value));
      iter_000 = iter_000->rest;
      idl_indent();
      idl_output_type_expression(((Cons*)(declaration->value)));
      *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(declaration->rest->value))->wrapper_value;
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
    }
  }
  idl_unbump_indent();
}

void idl_output_signature(Cons* signature, boolean outputmethodclassP) {
  idl_output_type_expression(((Cons*)(signature->rest->value)));
  if (outputmethodclassP &&
      ((boolean)(signature->value))) {
    *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(signature->value))->wrapper_value;
    *(oCURRENT_STREAMo.get()->native_stream) << "::";
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(signature->rest->rest->value))->wrapper_value;
  idl_output_formal_parameters(((Cons*)(signature->fourth())));
}

void idl_output_signatures(Cons* signatures) {
  idl_indent();
  idl_bump_indent();
  { Object* signature = NULL;
    Cons* iter_000 = signatures;

    while (!(iter_000 == NIL)) {
      signature = iter_000->value;
      iter_000 = iter_000->rest;
      idl_indent();
      idl_output_signature(((Cons*)(signature)), FALSE);
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
    }
  }
  idl_unbump_indent();
}

void startup_idl_output() {
  { 
    BIND_STELLA_SPECIAL(oMODULEo, Module*, oSTELLA_MODULEo);
    BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
    if (current_startup_time_phaseP(2)) {
      SGT_IDL_OUTPUT_STELLA_CONS = ((Surrogate*)(intern_rigid_symbol_wrt_module("CONS", NULL, 1)));
      SYM_IDL_OUTPUT_STELLA_IDL_COMMENT = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_COMMENT", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_TYPEDEF = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_TYPEDEF", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_ENUM = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_ENUM", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_INTERFACE = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_INTERFACE", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_STRUCT = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_STRUCT", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_DECLARATIONS = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_DECLARATIONS", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_IDENT = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_IDENT", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_TYPE = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_TYPE", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_SIGNATURES = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_SIGNATURES", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_IDL_VAR_ARGS = ((Symbol*)(intern_rigid_symbol_wrt_module("IDL_VAR_ARGS", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_STARTUP_IDL_OUTPUT = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-IDL-OUTPUT", NULL, 0)));
      SYM_IDL_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-STARTUP-CLASSNAME", NULL, 0)));
    }
    if (current_startup_time_phaseP(6)) {
      finalize_classes();
    }
    if (current_startup_time_phaseP(7)) {
      define_function_object("IDL-OUTPUT-PARSE-TREE", "(DEFUN IDL-OUTPUT-PARSE-TREE ((CONSTREE CONS)))", ((cpp_function_code)(&idl_output_parse_tree)), NULL);
      define_function_object("IDL-OUTPUT-STATEMENT", "(DEFUN IDL-OUTPUT-STATEMENT ((STATEMENT OBJECT)))", ((cpp_function_code)(&idl_output_statement)), NULL);
      define_function_object("IDL-INDENT", "(DEFUN IDL-INDENT ())", ((cpp_function_code)(&idl_indent)), NULL);
      define_function_object("IDL-BUMP-INDENT", "(DEFUN IDL-BUMP-INDENT ())", ((cpp_function_code)(&idl_bump_indent)), NULL);
      define_function_object("IDL-UNBUMP-INDENT", "(DEFUN IDL-UNBUMP-INDENT ())", ((cpp_function_code)(&idl_unbump_indent)), NULL);
      define_function_object("IDL-OUTPUT-TYPEDEF", "(DEFUN IDL-OUTPUT-TYPEDEF ((TYPEDEF CONS)))", ((cpp_function_code)(&idl_output_typedef)), NULL);
      define_function_object("IDL-OUTPUT-ENUMERANDS", "(DEFUN IDL-OUTPUT-ENUMERANDS ((ENUMERANDS (CONS OF CONS))))", ((cpp_function_code)(&idl_output_enumerands)), NULL);
      define_function_object("IDL-OUTPUT-ENUM", "(DEFUN IDL-OUTPUT-ENUM ((ENUM CONS)))", ((cpp_function_code)(&idl_output_enum)), NULL);
      define_function_object("IDL-OUTPUT-TYPE-EXPRESSION", "(DEFUN IDL-OUTPUT-TYPE-EXPRESSION ((TYPEEXPRESSION (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&idl_output_type_expression)), NULL);
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((OBJECT OBJECT)))", ((cpp_method_code)(&Object::idl_output_literal)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((STRING STRING)))", ((cpp_method_code)(NULL)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((STRING STRING-WRAPPER)))", ((cpp_method_code)(&String_Wrapper::idl_output_literal)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((STRING MUTABLE-STRING-WRAPPER)))", ((cpp_method_code)(&Mutable_String_Wrapper::idl_output_literal)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((TREE QUOTED-EXPRESSION)))", ((cpp_method_code)(&Quoted_Expression::idl_output_literal)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((SYMBOL SYMBOL)))", ((cpp_method_code)(&Symbol::idl_output_literal)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((SURROGATE SURROGATE)))", ((cpp_method_code)(&Surrogate::idl_output_literal)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD IDL-OUTPUT-LITERAL ((KEYWORD KEYWORD)))", ((cpp_method_code)(&Keyword::idl_output_literal)), ((cpp_method_code)(NULL)));
      define_function_object("IDL-OUTPUT-ATOMIC-EXPRESSION", "(DEFUN IDL-OUTPUT-ATOMIC-EXPRESSION ((ATOM OBJECT)))", ((cpp_function_code)(&idl_output_atomic_expression)), NULL);
      define_function_object("IDL-OUTPUT-COMMENT", "(DEFUN IDL-OUTPUT-COMMENT ((TREE STRING-WRAPPER)))", ((cpp_function_code)(&idl_output_comment)), NULL);
      define_function_object("IDL-OUTPUT-IDENTIFIER", "(DEFUN IDL-OUTPUT-IDENTIFIER ((IDENTIFIER STRING-WRAPPER)))", ((cpp_function_code)(&idl_output_identifier)), NULL);
      define_function_object("IDL-OUTPUT-DERIVED-CLASSES", "(DEFUN IDL-OUTPUT-DERIVED-CLASSES ((CLASS-LIST (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&idl_output_derived_classes)), NULL);
      define_function_object("IDL-OUTPUT-TEMPLATE-PARAMETERS", "(DEFUN IDL-OUTPUT-TEMPLATE-PARAMETERS ((PARAMETERS (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&idl_output_template_parameters)), NULL);
      define_function_object("IDL-OUTPUT-TEMPLATE-CLASSES?", "(DEFUN (IDL-OUTPUT-TEMPLATE-CLASSES? BOOLEAN) ())", ((cpp_function_code)(&idl_output_template_classesP)), NULL);
      define_function_object("IDL-OUTPUT-INTERFACE", "(DEFUN IDL-OUTPUT-INTERFACE ((CLASSDEF CONS)))", ((cpp_function_code)(&idl_output_interface)), NULL);
      define_function_object("IDL-OUTPUT-STRUCT", "(DEFUN IDL-OUTPUT-STRUCT ((CLASSDEF CONS)))", ((cpp_function_code)(&idl_output_struct)), NULL);
      define_function_object("IDL-OUTPUT-ONE-FORMAL-PARAMETER", "(DEFUN IDL-OUTPUT-ONE-FORMAL-PARAMETER ((PARAMETER (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&idl_output_one_formal_parameter)), NULL);
      define_function_object("IDL-OUTPUT-FORMAL-PARAMETERS", "(DEFUN IDL-OUTPUT-FORMAL-PARAMETERS ((PARAMETERS (CONS OF CONS))))", ((cpp_function_code)(&idl_output_formal_parameters)), NULL);
      define_function_object("IDL-OUTPUT-FUNCTION-SIGNATURE", "(DEFUN IDL-OUTPUT-FUNCTION-SIGNATURE ((FUNCTION CONS)))", ((cpp_function_code)(&idl_output_function_signature)), NULL);
      define_function_object("IDL-OUTPUT-DECLARATIONS", "(DEFUN IDL-OUTPUT-DECLARATIONS ((DECLARATIONS (CONS OF CONS))))", ((cpp_function_code)(&idl_output_declarations)), NULL);
      define_function_object("IDL-OUTPUT-SIGNATURE", "(DEFUN IDL-OUTPUT-SIGNATURE ((SIGNATURE CONS) (OUTPUTMETHODCLASS? BOOLEAN)))", ((cpp_function_code)(&idl_output_signature)), NULL);
      define_function_object("IDL-OUTPUT-SIGNATURES", "(DEFUN IDL-OUTPUT-SIGNATURES ((SIGNATURES CONS)))", ((cpp_function_code)(&idl_output_signatures)), NULL);
      define_function_object("STARTUP-IDL-OUTPUT", "(DEFUN STARTUP-IDL-OUTPUT () :PUBLIC? TRUE)", ((cpp_function_code)(&startup_idl_output)), NULL);
      { Method_Slot* function = lookup_function(SYM_IDL_OUTPUT_STELLA_STARTUP_IDL_OUTPUT);

        set_dynamic_slot_value(function->dynamic_slots, SYM_IDL_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME, wrap_string("Startup-Idl-Output"), NULL_STRING_WRAPPER);
      }
    }
    if (current_startup_time_phaseP(8)) {
      finalize_slots();
      cleanup_unfinalized_classes();
    }
    if (current_startup_time_phaseP(9)) {
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *IDL-INDENT-CHARS* INTEGER 0)");
    }
  }
}

Surrogate* SGT_IDL_OUTPUT_STELLA_CONS = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_COMMENT = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_TYPEDEF = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_ENUM = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_INTERFACE = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_STRUCT = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_DECLARATIONS = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_IDENT = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_TYPE = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_SIGNATURES = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_IDL_VAR_ARGS = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_STARTUP_IDL_OUTPUT = NULL;

Symbol* SYM_IDL_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME = NULL;

} // end of namespace stella
