// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/walk.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/


namespace stella {

// Class definitions:
class Translation_Unit : public Standard_Object {
public:
  Module* tu_home_module;
  Object* the_object;
  Symbol* category;
  char* annotation;
  boolean auxiliaryP;
  Object* code_register;
  Object* translation;
  List* referenced_globals;
public:
  virtual void print_object(ostream* stream);
  virtual Surrogate* primary_type();
  virtual Module* home_module();
};


// Global declarations:
extern List* oAVAILABLE_ENVIRONMENT_FEATURESo;
extern List* oCURRENT_ENVIRONMENT_FEATURESo;
extern List* oDEFAULT_ENVIRONMENT_FEATURESo;
extern List* oTRACED_KEYWORDSo;
extern DECLARE_STELLA_SPECIAL(oSAFETYo, int );
extern DECLARE_STELLA_SPECIAL(oDEBUGLEVELo, int );
extern DECLARE_STELLA_SPECIAL(oOPTIMIZESPEEDLEVELo, int );
extern DECLARE_STELLA_SPECIAL(oOPTIMIZESPACELEVELo, int );
extern String_Hash_Table* oQUOTATION_TABLEo;
extern DECLARE_STELLA_SPECIAL(oTRANSLATIONUNITSo, List* );
extern DECLARE_STELLA_SPECIAL(oCURRENTTRANSLATIONUNITo, Translation_Unit* );
extern DECLARE_STELLA_SPECIAL(oTRANSLATIONPHASEo, Keyword* );
extern DECLARE_STELLA_SPECIAL(oTRANSLATIONVERBOSITYLEVELo, int );
extern DECLARE_STELLA_SPECIAL(oUSEHARDCODEDSYMBOLSpo, boolean );
extern DECLARE_STELLA_SPECIAL(oTRANSLATOROUTPUTLANGUAGEo, Keyword* );
extern DECLARE_STELLA_SPECIAL(oLOCALVARIABLETYPETABLEo, Key_Value_List* );
extern DECLARE_STELLA_SPECIAL(oMETHODBEINGWALKEDo, Method_Slot* );
extern DECLARE_STELLA_SPECIAL(oFOUNDRETURNpo, boolean );
extern DECLARE_STELLA_SPECIAL(oTARGETTYPEo, Standard_Object* );
extern DECLARE_STELLA_SPECIAL(oLOCALGENSYMTABLEo, Key_Value_List* );
extern DECLARE_STELLA_SPECIAL(oTRANSLATIONERRORSo, int );
extern DECLARE_STELLA_SPECIAL(oTRANSLATIONWARNINGSo, int );
extern DECLARE_STELLA_SPECIAL(oIGNORETRANSLATIONERRORSpo, boolean );
extern Output_Stream* oFUNCTION_CALL_LOG_STREAMo;
extern boolean oLOG_FUNCTION_CALLSpo;
extern int oLOG_BREAK_POINT_COUNTERo;
extern Cons* oWRAPPED_TYPE_TABLEo;
extern Cons* oCOERSION_TABLEo;
extern Hash_Table* oSYMBOL_REGISTRYo;
extern List* oSYMBOL_SETo;
extern DECLARE_STELLA_SPECIAL(oCURRENTFILEo, char* );
extern DECLARE_STELLA_SPECIAL(oSPECIALVARIABLESTACKo, Key_Value_List* );
extern DECLARE_STELLA_SPECIAL(oSPECIALSENABLEDpo, boolean );
extern DECLARE_STELLA_SPECIAL(oNOFSPECIALSATLOOPENTRYo, int );
extern Cons* oTYPE_PREDICATE_TABLEo;
extern List* oNUMERIC_TYPE_HIERARCHYo;
extern DECLARE_STELLA_SPECIAL(oINLININGMETHODCALLpo, boolean );
extern Keyword* oMIXIN_IMPLEMENTATION_STYLEo;
extern Hash_Table* oMACRO_TABLEo;
extern int oMAX_NUMBER_OF_STARTUP_UNITSo;
extern Hash_Table* oNATIVE_NAME_TABLEo;
extern DECLARE_STELLA_SPECIAL(oEVALUATIONTREEo, Object* );
extern DECLARE_STELLA_SPECIAL(oEVALUATIONPARENTTREEo, Object* );

// Function signatures:
void display_environment_features();
void enable_environment_feature(int features, ...);
void disable_environment_feature(int features, ...);
void reset_environment_features();
Object* trace_if_expander(Object* keyword, Cons* body);
boolean trace_keywordP(Object* keyword);
List* add_trace(Cons* keywords);
List* add_trace_evaluator_wrapper(Cons* arguments);
List* drop_trace(Cons* keywords);
List* drop_trace_evaluator_wrapper(Cons* arguments);
void clear_trace();
void set_optimization_levels(int safety, int debug, int speed, int space);
boolean preserve_tail_merge_optimizabilityP();
boolean method_call_inlining_enabledP();
boolean optimize_boolean_testsP();
boolean check_for_illegal_returnP();
char* name_quoted_tree(Cons* tree);
Cons* get_quoted_tree(char* tree_name, char* modulename);
Translation_Unit* new_translation_unit();
Object* access_translation_unit_slot_value(Translation_Unit* self, Symbol* slotname, Object* value, boolean setvalueP);
void clear_translation_unit(Translation_Unit* self);
void print_translation_unit(Translation_Unit* self, ostream* stream);
boolean use_hardcoded_symbolsP();
Keyword* translator_output_language();
char* translator_output_language_name();
Keyword* set_translator_output_language(Keyword* new_language);
boolean translate_to_common_lispP();
boolean translate_to_cppP();
boolean translate_to_javaP();
boolean translate_to_single_inheritance_languageP();
Keyword* toggle_output_language();
boolean use_bootstrap_translatorP();
Keyword* toggle_translators();
boolean declaration_operatorP(Symbol* renamed_Operator);
boolean declaration_treeP(Cons* tree);
char* create_annotation(Cons* top_level_tree);
void walk_top_level_tree(Cons* tree, boolean createannotationP);
Object* walk_top_level_expression(Object* tree);
void walk_phase_one_unit(Translation_Unit* unit);
void walk_auxiliary_tree(Cons* tree);
Translation_Unit* help_walk_auxiliary_tree(Cons* tree, boolean finalizeP);
void walk_all_phase_one_units();
void translate_all_units();
boolean unit_included_in_other_unitsP(Translation_Unit* unit);
Cons* combine_translated_trees();
Object* translate_walked_tree(Object* codetree);
Object* incrementally_translate(Object* tree);
void reset_translation_errors();
void signal_translation_error();
void signal_translation_warning();
boolean ignore_translation_errorsP();
boolean translation_errorsP();
void summarize_translation_errors();
void print_error_context(char* prefix, Output_Stream* stream);
boolean log_function_callP(Method_Slot* method);
Cons* wrap_body_with_log_function_call_tree(Method_Slot* method, Cons* body);
void log_function_call(char* name);
void start_function_call_logging(char* filename);
void start_function_call_logging_evaluator_wrapper(Cons* arguments);
void stop_function_call_logging();
void set_call_log_break_point(int count);
void set_call_log_break_point_evaluator_wrapper(Cons* arguments);
void break_program(char* message);
void terminate_program();
void po(Object* thing);
boolean variable_eqlP(Symbol* var1, Symbol* var2);
Object* lookup_variable_table(Key_Value_List* self, Symbol* variable);
void insert_at_variable_table(Key_Value_List* self, Symbol* variable, Object* value);
void push_variable_binding(Symbol* variable, Standard_Object* type);
void pop_variable_binding();
Standard_Object* lookup_variable_type(Symbol* variablename);
void set_local_variable_info(Symbol* variable, Keyword* key, Object* info);
Object* get_local_variable_info(Symbol* variable, Keyword* key);
void register_reference_to_global_variable(Symbol* variablename);
Symbol* local_gensym(char* prefix);
Symbol* yield_local_variable_alias(Symbol* variable, int level);
boolean rename_shadowing_local_variablesP();
void maybe_rename_local_variable(Symbol* variable);
Symbol* true_variable_name(Symbol* variable);
boolean suppress_warningsP();
boolean bad_argument_rangeP(Cons* tree, int minarity, int maxarity);
boolean bad_argument_countP(Cons* tree, int arity);
Cons* yield_illegal_statement_tree();
Object* yield_illegal_expression_tree();
Cons* walk_dont_call_me_tree(Object* tree, Standard_Object* returntype, Standard_Object*& _return1);
boolean illegal_treeP(Object* tree);
boolean native_class_method_inliningP();
Object* prognify(Cons* trees);
Object* optimize_progn(Cons* progn_tree);
Cons* tree_to_trees(Object* tree);
Surrogate* wrapped_type_to_type(Surrogate* self);
Surrogate* wrapper_value_type(Wrapper* self);
Object* lookup_coersion_method(Surrogate* sourcetype, Surrogate* targettype, Object* expression);
Object* apply_coercion_method(Object* expression, Surrogate* sourcetype, Surrogate* targettype, Object* coercionmethod, Standard_Object*& _return1);
boolean translating_codeP();
Surrogate* verify_type(Surrogate* self);
boolean safe_subtype_ofP(Surrogate* subtype, Surrogate* supertype);
void warn_about_unknown_source_type(Object* tree);
Object* coerce_a_tree(Object* tree, Standard_Object* sourcetype, Standard_Object* targettype, Standard_Object*& _return1);
Object* help_coerce_a_tree(Object* tree, Standard_Object* sourcetype, Standard_Object* targettype, boolean testonlyP, Standard_Object*& _return1, boolean& _return2);
boolean coercibleP(Object* tree, Standard_Object* sourcetype, Standard_Object* targettype);
boolean walking_expressionP();
Object* walk_expression_tree(Object* exptree, Standard_Object* targettype, Symbol* operatorname, boolean vrletisokP, Standard_Object*& _return1);
Object* walk_without_type_tree(Object* tree);
Cons* walk_list_of_trees(Cons* trees);
Cons* walk_list_of_statements(Cons* trees);
Object* walk_statement(Object* tree, boolean warnonatomP);
Cons* eliminate_vrlet_statement(Cons* tree);
Cons* sys_tree(Object* tree, Standard_Object* typespec, Standard_Object*& _return1);
Standard_Object* walked_expression_type(Object* tree);
boolean need_identical_method_signaturesP();
Standard_Object* compute_most_general_return_type(Method_Slot* method, Standard_Object* returntype);
Standard_Object* compute_real_slot_type(Storage_Slot* slot, Standard_Object* firstargtype, Standard_Object* returntype);
Object* sys_tree_if_needed(Slot* slot, Object* tree, Standard_Object* firstargtype, Standard_Object* returntype, Standard_Object*& _return1);
Surrogate* target_language_type(Object* tree);
Cons* set_target_language_type(Cons* systree, Surrogate* type, Standard_Object*& _return1);
Object* walk_a_tree(Object* tree, Standard_Object*& _return1);
Object* help_walk_a_tree(Object* tree, Standard_Object*& _return1);
Cons* walk_a_cons_tree(Cons* tree, Standard_Object*& _return1);
boolean incremental_translationP();
char* construct_symbol_constant_name(Generalized_Symbol* symbol);
Symbol* yield_symbol_constant_name(Generalized_Symbol* symbol);
Symbol* create_startup_symbol(Generalized_Symbol* symbol);
Generalized_Symbol* register_symbol(Generalized_Symbol* symbol);
void clear_symbol_registry();
Cons* yield_hardcoded_intern_registered_symbols_tree();
Surrogate* lookup_constant_symbol(Symbol* self);
boolean constant_symbolP(Symbol* symbol);
Symbol* walk_constant_symbol(Symbol* self, Surrogate*& _return1);
boolean atomic_expressionP(Object* tree);
boolean variable_expressionP(Object* tree);
boolean vrlet_expressionP(Object* tree);
boolean procedural_expressionP(Object* tree);
boolean substitute_once(Object* expression, Object* newtree, Object* oldtree);
Cons* transform_vrlet_expression(Cons* statement, Cons* vrexpression, Standard_Object*& _return1);
Cons* help_transform_boolean_procedural_expression(Object* expression, Symbol* testvariable);
Cons* transform_boolean_procedural_expression(Cons* statement, Cons* vrexpression, Standard_Object*& _return1);
Cons* percolate_out_boolean_vrlet_expressions(Cons* booleanexpression);
Cons* transform_procedural_expression(Cons* statement, Cons* vrexpression, Standard_Object* type, Standard_Object*& _return1);
Cons* percolate_out_vrlet_expression(Cons* statement, Cons* vrexpression, Standard_Object* type, Standard_Object*& _return1);
Cons* walk_setq_tree(Cons* tree, Standard_Object*& _return1);
Cons* yield_fixed_slot_value_setter_tree(Slot* slot, Object* objectref, Object* valuetree);
Cons* walk_setf_tree(Cons* tree, Standard_Object*& _return1);
Cons* yield_dynamic_slot_value_tree(Storage_Slot* slot, Object* objectref, Standard_Object* returntype);
Cons* yield_dynamic_slot_value_setter_tree(Storage_Slot* slot, Object* objectref, Object* valueref, Standard_Object* returntype);
Cons* yield_native_slot_value_tree(Storage_Slot* slot, Object* objectref, Standard_Object* objecttype);
Cons* yield_context_sensitive_slot_value_tree(Storage_Slot* slot, Object* objectref, Standard_Object* returntype, Cons* csoptions, Standard_Object*& _return1);
Cons* yield_slot_value_tree(Storage_Slot* slot, Object* objectref, Standard_Object* objecttype, Standard_Object* returntype, Cons* csoptions, Standard_Object*& _return1);
Cons* walk_slot_value_tree(Cons* tree, Standard_Object*& _return1);
Cons* yield_native_slot_value_setter_tree(Storage_Slot* slot, Object* objectref, Standard_Object* objecttype, Object* valueref);
Cons* yield_context_sensitive_slot_value_setter_tree(Storage_Slot* slot, Object* objectref, Object* valueref, Standard_Object* returntype, Cons* csoptions, Standard_Object*& _return1);
Cons* yield_slot_value_setter_tree(Storage_Slot* slot, Object* objectref, Standard_Object* objecttype, Object* valueref, Standard_Object* returntype, Cons* csoptions, Standard_Object*& _return1);
Cons* walk_slot_value_setter_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_aref_tree(Cons* tree, Standard_Object*& _return1);
Standard_Object* safe_yield_type_specifier(Object* typetree);
Cons* walk_a_declaration(Symbol* variable, Object* typetree, Object* value, boolean inputparameterP);
Cons* walk_variable_declarations(Cons* declarations);
Cons* transform_let_with_procedural_expression(Cons* tree);
void pop_local_variable_bindings(Cons* declarations);
Cons* walk_let_tree(Cons* tree, Standard_Object*& _return1);
Keyword* special_implementation_style();
void push_special(Symbol* variable, Symbol* oldvaluevariable);
void pop_special();
Symbol* lookup_old_value_variable(Symbol* variable);
boolean need_to_unbind_specialsP();
Cons* yield_special_unbind_tree(int nofbindings);
Cons* yield_return_special_unbind_tree();
Cons* yield_loop_exit_special_unbind_tree();
Cons* walk_special_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_cl_special_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_unwind_protect_special_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_cast_tree(Cons* tree, Standard_Object*& _return1);
boolean values_treeP(Object* tree);
Cons* walk_values_tree(Cons* tree, Standard_Object*& _return1);
Object* walk_mv_expression_tree(Object* tree, List* targettypes, Symbol* renamed_Operator, Cons*& _return1, List*& _return2);
List* listify_type_spec(Standard_Object* typespec);
Slot* slot_from_expression_tree(Cons* tree);
Object* walk_mv_tree(Object* tree, Cons*& _return1, List*& _return2);
Cons* walk_mv_values_tree(Cons* tree, Cons*& _return1, List*& _return2);
Object* coerce_mv_tree(Object* tree, Symbol* renamed_Operator, List* sourcetypes, List* targettypes, Cons*& _return1, List*& _return2);
Cons* walk_return_and_unbind_specials(Cons* tree, Standard_Object*& _return1);
Cons* walk_return_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_mv_setq_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_mv_bind_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_loop_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_loop_exit_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_while_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_conditional_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_choose_tree(Cons* tree, Standard_Object*& _return1);
Object* walk_boolean_tree(Cons* tree, Standard_Object*& _return1);
boolean and_or_not_treeP(Object* tree);
Object* help_walk_boolean_tree(Cons* tree);
Cons* walk_cond_tree(Cons* tree, Standard_Object*& _return1);
Cons* cond_tree_to_if_tree(Cons* tree);
Object* yield_hardcoded_case_symbol_id_or_ids(Object* casetest);
Cons* walk_hardcoded_symbol_case_tree(Cons* tree, Standard_Object*& _return1);
Cons* yield_isaP_case_test(Surrogate* casekey, Object* testexpression);
Cons* yield_subtype_ofP_case_test(Surrogate* casekey, Object* testexpression);
Cons* yield_cond_test(Object* casetest, Object* testvariable, Symbol* equalitytest);
Object* yield_cond_test_or_tests(Object* casetest, Object* testvariable, Symbol* equalitytest);
int count_case_test_clauses(Cons* tree, boolean& _return1);
Cons* attach_unhandled_case_error_clause(Cons* casetree, Object* testtree);
Cons* walk_non_built_in_case_tree(Cons* tree, Symbol* equalitytest, Standard_Object*& _return1);
Cons* walk_case_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_typecase_tree(Cons* tree, Standard_Object*& _return1);
Cons* yield_casted_typecase_clause_trees(Symbol* testvariable, Standard_Object* clausetype, Cons* clausetrees);
void verify_typecase_clause_type(Surrogate* testtype, Surrogate* clausetype, List* precedingclausetypes, Cons* clause);
Cons* finish_walking_eql_tree(Cons* tree, Surrogate* type1, Surrogate* type2, Standard_Object*& _return1);
Cons* finish_walking_equal_tree(Cons* tree, Surrogate* type1, Surrogate* type2, Standard_Object*& _return1);
Object* walk_equality_tree(Cons* tree, Standard_Object*& _return1);
Surrogate* more_general_numeric_type(Surrogate* type1, Surrogate* type2);
Cons* yield_arithmetic_operator_call_tree(Symbol* renamed_Operator, Cons* operands);
Cons* yield_nested_arithmetic_operator_call_tree(Symbol* renamed_Operator, Cons* operands);
Object* walk_arithmetic_tree(Cons* tree, Surrogate*& _return1);
Object* walk_quoted_tree(Cons* tree, Standard_Object*& _return1);
Object* walk_bquote_tree(Cons* tree, Standard_Object*& _return1);
Object* expand_macro(Cons* tree);
Object* walk_macro_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_print_stream_tree(Cons* tree, Standard_Object*& _return1);
boolean warn_about_undefined_methodsP();
boolean warn_about_missing_methodsP();
Cons* walk_undefined_slot_tree(Cons* tree, Standard_Object* firstargtype, boolean warnP, Surrogate*& _return1);
Cons* walk_slot_on_abstract_type_tree(Cons* tree, Surrogate* abstracttype, Standard_Object*& _return1);
Method_Slot* find_prototype_method(Symbol* methodname, Surrogate* abstracttype);
int compatible_real_methods(Method_Slot* prototypemethod, Surrogate* abstracttype, int& _return1, boolean& _return2);
boolean string_concatenate_methodP(Method_Slot* method);
boolean pass_variable_arguments_as_listP(Method_Slot* method);
Standard_Object* variable_arguments_type(Method_Slot* method);
Symbol* variable_arguments_name(Method_Slot* method);
Standard_Object* yield_listified_variable_arguments_type(Method_Slot* method);
Cons* yield_listified_variable_arguments(Cons* walkedargs, Standard_Object* targettype, boolean wrapargsP);
Object* finish_walking_argument_list_tree(Slot* self, Cons* tree, Standard_Object* firstargtype, Standard_Object*& _return1);
Cons* walk_variable_arguments(Cons* arguments, Method_Slot* method);
Cons* quote_arguments(Method_Slot* method, Cons* arguments);
Standard_Object* walk_first_argument_to_function(Method_Slot* fnslot, Cons* tree);
Object* walk_call_slot_tree(Cons* tree, Standard_Object*& _return1);
boolean inline_method_callP(Method_Slot* method);
boolean method_inlinableP(Method_Slot* method);
boolean most_specific_methodP(Method_Slot* method);
boolean help_most_specific_methodP(Class* renamed_Class, Method_Slot* method);
Object* inlinable_method_body(Method_Slot* method);
Object* walk_inline_method_call(Method_Slot* method, Cons* walkedargs);
Cons* yield_verbatim_inline_call_tree(Method_Slot* method, Cons* walkedargs);
boolean inline_variable_referenceP(Symbol* self);
Cons* walk_inline_variable_reference(Symbol* self, Standard_Object*& _return1);
boolean side_effect_free_expressionP(Object* tree);
int estimated_evaluation_cost(Object* tree);
Cons* yield_synthesized_method_body(Translation_Unit* unit);
Cons* walk_method_object(Translation_Unit* unit);
void walk_defmethod_tree(Cons* tree);
void walk_method_unit(Translation_Unit* unit);
void print_undefined_methods(Module* module, boolean localP);
Cons* walk_sys_call_tree(Cons* tree, Standard_Object*& _return1);
void walk_defclass_tree(Cons* tree);
Cons* yield_initialize_hardwired_slots(Class* renamed_Class);
Object* yield_initial_value_expression(Storage_Slot* slot);
Cons* yield_constructor_attachment(Class* renamed_Class, Symbol* classref);
void cleanup_auxiliary_methods(Class* renamed_Class);
void register_auxiliary_method(Method_Slot* method, Slot* reason);
boolean mixin_type_variables_allowedP();
boolean create_native_mixin_slot_accessorsP();
void create_accessor_units_for_slot(Storage_Slot* slot, Class* renamed_Class, boolean mixinaccessorsP, boolean signaturesonlyP);
void create_accessor_units_for_mixin_slot(Storage_Slot* slot, Class* renamed_Class);
void create_slot_accessor_units(Class* renamed_Class);
void create_inline_method_units(Class* renamed_Class);
Cons* yield_mixin_method_tree(Method_Slot* method, Class* renamed_Class);
void create_mixin_method_units(Class* renamed_Class);
void create_defprint_unit(Class* renamed_Class);
void walk_class_unit(Translation_Unit* unit);
void create_finalization_units();
void walk_defslot_tree(Cons* tree);
void walk_slot_unit(Translation_Unit* unit);
Method_Slot* lookup_macro(Symbol* name);
void store_macro(Symbol* name, Symbol* expandername, cpp_function_code expandercode);
void undefine_macro(Symbol* name);
Symbol* yield_macro_expander_function_name(Symbol* macroname);
void walk_defmacro_tree(Cons* tree);
void walk_macro_unit(Translation_Unit* unit);
void walk_defglobal_tree(Cons* tree);
void walk_global_unit(Translation_Unit* unit);
void walk_deftype_tree(Cons* tree);
void walk_type_unit(Translation_Unit* unit);
void walk_startup_time_progn_tree(Cons* tree);
Keyword* extract_startup_time_phase(Cons* tree);
void walk_startup_time_progn_unit(Translation_Unit* unit);
boolean earlier_startup_unitP(Translation_Unit* unit1, Translation_Unit* unit2);
Cons* combine_startup_function_units(Symbol* startupfnname);
void extract_startup_function_units(List* startupunits, Symbol* startupfnname);
Symbol* yield_startup_function_name(char* file);
void create_startup_function_units();
boolean dont_generate_startup_codeP();
void remove_all_startup_time_progn_units();
Cons* walk_signal_exception_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_exception_case_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_exception_handler_trees(Cons* tree);
Cons* walk_unwind_protect_tree(Cons* tree, Surrogate*& _return1);
void walk_verbatim_definition_tree(Cons* tree);
void walk_verbatim_unit(Translation_Unit* unit);
Object* walk_verbatim_tree(Cons* tree, Standard_Object*& _return1);
Object* lookup_verbatim_tree(Cons* tree, Keyword* language);
boolean verbatim_treeP(Object* tree);
void walk_defmodule_tree(Cons* tree);
void walk_module_unit(Translation_Unit* unit);
Cons* extract_required_argument_values(Standard_Object* classtype, Property_List* slotsandvalues);
void preprocess_array_arguments(Parametric_Type_Specifier* arraytype, Property_List* slotsandvalues);
void evaluate_array_argument_value(Parametric_Type_Specifier* arraytype, List* requiredvalues, Slot* slot, Object* valueref);
Cons* yield_new_arguments_tree(Cons* keywordsandvalues, Standard_Object* classtype, Symbol* selfvariable, Cons*& _return1);
Cons* walk_new_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_make_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_funcall_tree(Cons* tree, Standard_Object*& _return1);
Cons* walk_the_code_tree(Cons* tree, Standard_Object*& _return1);
Cons* de_uglify_arguments(Cons* uglyarguments);
Object* de_uglify_parse_tree(Object* tree);
void register_native_name(Symbol* name, Keyword* language, Keyword* category);
boolean native_nameP(Symbol* name, Keyword* language, Keyword* category);
Symbol* yield_renamed_name_if_native(Symbol* name, Keyword* language, Keyword* category);
boolean method_needs_lisp_macroP(Method_Slot* method);
Cons* yield_lisp_macro_trees(Symbol* name, Method_Slot* method, Cons*& _return1);
void create_lisp_macro_units(Symbol* name, Method_Slot* method);
boolean commandP(Method_Slot* method);
Method_Slot* lookup_command(Symbol* name);
boolean method_must_be_evaluableP(Method_Slot* method);
boolean method_needs_evaluator_wrapperP(Method_Slot* method);
Symbol* yield_evaluator_wrapper_name(Symbol* methodname);
Object* yield_argument_access_tree(Symbol* argumentsvariable, int index, boolean restargumentP);
Cons* yield_evaluator_wrapper_tree(Method_Slot* method);
Method_Slot* create_evaluator_wrapper_unit(Method_Slot* method);
Object* evaluate(Object* expression);
Object* evaluate_string(char* expression);
Object* try_to_evaluate(Object* tree);
Object* evaluate_cons_tree(Cons* tree, Standard_Object*& _return1);
Object* evaluate_argument_tree(Object* tree, boolean evaluateP, Standard_Object*& _return1);
Object* evaluate_atomic_tree(Object* tree, Standard_Object*& _return1);
Object* coerce_evaluated_tree(Object* tree, Object* sourcetree, Standard_Object* sourcetype, Standard_Object* targettype, boolean evaluateP, Standard_Object*& _return1);
void help_startup_walk1();
void help_startup_walk2();
void help_startup_walk3();
void help_startup_walk4();
void help_startup_walk5();
void help_startup_walk6();
void help_startup_walk7();
void help_startup_walk8();
void help_startup_walk9();
void help_startup_walk10();
void help_startup_walk11();
void help_startup_walk12();
void help_startup_walk13();
void help_startup_walk14();
void startup_walk();

// Auxiliary global declarations:
extern Keyword* KWD_WALK_WARN_ABOUT_UNDEFINED_METHODS;
extern Keyword* KWD_WALK_SUPPRESS_WARNINGS;
extern Keyword* KWD_WALK_WARN_ABOUT_MISSING_METHODS;
extern Keyword* KWD_WALK_USE_HARDCODED_SYMBOLS;
extern Keyword* KWD_WALK_USE_COMMON_LISP_STRUCTS;
extern Keyword* KWD_WALK_USE_COMMON_LISP_VECTOR_STRUCTS;
extern Keyword* KWD_WALK_USE_COMMON_LISP_CONSES;
extern Keyword* KWD_WALK_USE_CPP_GARBAGE_COLLECTOR;
extern Keyword* KWD_WALK_TRANSLATE_WITH_COPYRIGHT_HEADER;
extern Symbol* SYM_WALK_STELLA_WHEN;
extern Symbol* SYM_WALK_STELLA_AND;
extern Symbol* SYM_WALK_STELLA_DEFINEDp;
extern Symbol* SYM_WALK_STELLA_oTRACED_KEYWORDSo;
extern Symbol* SYM_WALK_STELLA_PRINT;
extern Symbol* SYM_WALK_STELLA_EXISTS;
extern Symbol* SYM_WALK_STELLA_KWD;
extern Symbol* SYM_WALK_STELLA_IN;
extern Symbol* SYM_WALK_STELLA_QUOTE;
extern Symbol* SYM_WALK_STELLA_WHERE;
extern Symbol* SYM_WALK_STELLA_MEMBp;
extern Symbol* SYM_WALK_STELLA_TRACE_IF;
extern Symbol* SYM_WALK_STELLA_TRACE_IF_EXPANDER;
extern Keyword* KWD_WALK_JAVA;
extern Surrogate* SGT_WALK_STELLA_TRANSLATION_UNIT;
extern Symbol* SYM_WALK_STELLA_TU_HOME_MODULE;
extern Symbol* SYM_WALK_STELLA_THE_OBJECT;
extern Symbol* SYM_WALK_STELLA_CATEGORY;
extern Symbol* SYM_WALK_STELLA_ANNOTATION;
extern Symbol* SYM_WALK_STELLA_AUXILIARYp;
extern Symbol* SYM_WALK_STELLA_CODE_REGISTER;
extern Symbol* SYM_WALK_STELLA_TRANSLATION;
extern Symbol* SYM_WALK_STELLA_REFERENCED_GLOBALS;
extern Symbol* SYM_WALK_STELLA_CLASS;
extern Symbol* SYM_WALK_STELLA_METHOD;
extern Symbol* SYM_WALK_STELLA_MACRO;
extern Symbol* SYM_WALK_STELLA_GLOBAL_VARIABLE;
extern Keyword* KWD_WALK_COMMON_LISP;
extern Keyword* KWD_WALK_CPP;
extern Keyword* KWD_WALK_CPP_STANDALONE;
extern Keyword* KWD_WALK_IDL;
extern Symbol* SYM_WALK_STELLA_PROGN;
extern Surrogate* SGT_WALK_STELLA_CONS;
extern Symbol* SYM_WALK_STELLA_DEFCLASS;
extern Symbol* SYM_WALK_STELLA_DEFSLOT;
extern Symbol* SYM_WALK_STELLA_DEFMETHOD;
extern Symbol* SYM_WALK_STELLA_DEFUN;
extern Symbol* SYM_WALK_STELLA_DEFOPERATOR;
extern Symbol* SYM_WALK_STELLA_DEFGLOBAL;
extern Symbol* SYM_WALK_STELLA_DEFSPECIAL;
extern Symbol* SYM_WALK_STELLA_DEFCONSTANT;
extern Symbol* SYM_WALK_STELLA_DEFTYPE;
extern Symbol* SYM_WALK_STELLA_DEFMODULE;
extern Symbol* SYM_WALK_STELLA_DEFMACRO;
extern Symbol* SYM_WALK_STELLA_STARTUP_TIME_PROGN;
extern Symbol* SYM_WALK_STELLA_VERBATIM;
extern Symbol* SYM_WALK_STELLA_MODULE;
extern Symbol* SYM_WALK_STELLA_TYPE;
extern Symbol* SYM_WALK_STELLA_PRINT_METHOD;
extern Symbol* SYM_WALK_STELLA_SLOT;
extern Keyword* KWD_WALK_JAVA_STANDALONE;
extern Symbol* SYM_WALK_STELLA_METHOD_CONSTRUCTORp;
extern Keyword* KWD_WALK_DEFINE;
extern Keyword* KWD_WALK_FINALIZE;
extern Keyword* KWD_WALK_WALK;
extern Keyword* KWD_WALK_TRANSLATE;
extern Surrogate* SGT_WALK_STELLA_VOID;
extern Surrogate* SGT_WALK_STELLA_GLOBAL_VARIABLE;
extern Surrogate* SGT_WALK_STELLA_TYPE_SPEC;
extern Surrogate* SGT_WALK_STELLA_MODULE;
extern Symbol* SYM_WALK_STELLA_SLOT_AUXILIARYp;
extern Symbol* SYM_WALK_STELLA_METHOD_GLOBALLY_INLINEp;
extern Symbol* SYM_WALK_STELLA_LOG_FUNCTION_CALL;
extern Symbol* SYM_WALK_STELLA_START_FUNCTION_CALL_LOGGING;
extern Symbol* SYM_WALK_STELLA_STOP_FUNCTION_CALL_LOGGING;
extern Symbol* SYM_WALK_STELLA_SET_CALL_LOG_BREAK_POINT;
extern Symbol* SYM_WALK_STELLA_BREAK_PROGRAM;
extern Symbol* SYM_WALK_STELLA_TERMINATE_PROGRAM;
extern Symbol* SYM_WALK_STELLA_PO;
extern Symbol* SYM_WALK_STELLA_NULLp;
extern Symbol* SYM_WALK_STELLA_EQp;
extern Symbol* SYM_WALK_STELLA_EQLp;
extern Symbol* SYM_WALK_STELLA_l;
extern Symbol* SYM_WALK_STELLA_le;
extern Symbol* SYM_WALK_STELLA_g;
extern Symbol* SYM_WALK_STELLA_ge;
extern Symbol* SYM_WALK_STELLA_CAST;
extern Surrogate* SGT_WALK_STELLA_UNKNOWN;
extern Surrogate* SGT_WALK_STELLA_LISP_CODE;
extern Surrogate* SGT_WALK_STELLA_OUTPUT_STREAM;
extern Surrogate* SGT_WALK_STELLA_NATIVE_OUTPUT_STREAM;
extern Symbol* SYM_WALK_STELLA_INLINE;
extern Surrogate* SGT_WALK_STELLA_UNINITIALIZED;
extern Keyword* KWD_WALK_SECOND_CLASS;
extern Surrogate* SGT_WALK_STELLA_KEY_VALUE_LIST;
extern Symbol* SYM_WALK_STELLA_NULL;
extern Keyword* KWD_WALK_TYPE;
extern Keyword* KWD_WALK_ALIAS;
extern Symbol* SYM_WALK_STELLA_ERROR;
extern Symbol* SYM_WALK_STELLA_EOL;
extern Symbol* SYM_WALK_STELLA_ILLEGAL_EXPRESSION_FLAGGED_BY_THE_TRANSLATOR;
extern Symbol* SYM_WALK_STELLA_BAD_SYS;
extern Surrogate* SGT_WALK_STELLA_INTEGER_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_INTEGER;
extern Surrogate* SGT_WALK_STELLA_FLOAT_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_FLOAT;
extern Surrogate* SGT_WALK_STELLA_NUMBER_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_NUMBER;
extern Surrogate* SGT_WALK_STELLA_STRING_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_STRING;
extern Surrogate* SGT_WALK_STELLA_MUTABLE_STRING_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_MUTABLE_STRING;
extern Surrogate* SGT_WALK_STELLA_CHARACTER_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_CHARACTER;
extern Surrogate* SGT_WALK_STELLA_BOOLEAN_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_BOOLEAN;
extern Surrogate* SGT_WALK_STELLA_FUNCTION_CODE_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_FUNCTION_CODE;
extern Surrogate* SGT_WALK_STELLA_METHOD_CODE_WRAPPER;
extern Surrogate* SGT_WALK_STELLA_METHOD_CODE;
extern Surrogate* SGT_WALK_STELLA_OBJECT;
extern Symbol* SYM_WALK_STELLA_INLINE_WRAP_BOOLEAN;
extern Symbol* SYM_WALK_STELLA_WRAP_LITERAL;
extern Symbol* SYM_WALK_STELLA_INTEGER_TO_BOOLEAN_WRAPPER;
extern Symbol* SYM_WALK_STELLA_INTEGER_TO_BOOLEAN;
extern Symbol* SYM_WALK_STELLA_MUTABLE_STRING_TO_STRING;
extern Symbol* SYM_WALK_STELLA_STRING_TO_MUTABLE_STRING;
extern Surrogate* SGT_WALK_STELLA_SYMBOL;
extern Symbol* SYM_WALK_STELLA_INTERN_SYMBOL;
extern Symbol* SYM_WALK_STELLA_CHARACTER_TO_STRING;
extern Symbol* SYM_WALK_STELLA_SYMBOL_NAME;
extern Symbol* SYM_WALK_STELLA_INLINE_UNWRAP_BOOLEAN;
extern Symbol* SYM_WALK_STELLA_WRAPPER_VALUE;
extern Symbol* SYM_WALK_STELLA_NUMBER_WRAPPER_TO_FLOAT;
extern Surrogate* SGT_WALK_STELLA_SURROGATE;
extern Surrogate* SGT_WALK_STELLA_CLASS;
extern Symbol* SYM_WALK_STELLA_SURROGATE_VALUE;
extern Surrogate* SGT_WALK_STELLA_INPUT_STREAM;
extern Surrogate* SGT_WALK_STELLA_NATIVE_INPUT_STREAM;
extern Symbol* SYM_WALK_STELLA_NATIVE_STREAM;
extern Symbol* SYM_WALK_STELLA_lXg;
extern Surrogate* SGT_WALK_STELLA_SINGLE_FLOAT;
extern Symbol* SYM_WALK_STELLA_IDENTITY;
extern Surrogate* SGT_WALK_STELLA_DOUBLE_FLOAT;
extern Surrogate* SGT_WALK_STELLA_SHORT_INTEGER;
extern Surrogate* SGT_WALK_STELLA_LONG_INTEGER;
extern Surrogate* SGT_WALK_STELLA_UNSIGNED_SHORT_INTEGER;
extern Surrogate* SGT_WALK_STELLA_UNSIGNED_LONG_INTEGER;
extern Symbol* SYM_WALK_STELLA_VRLET;
extern Symbol* SYM_WALK_STELLA_SYS_CALL_METHOD;
extern Symbol* SYM_WALK_STELLA_SYS_CALL_FUNCTION;
extern Symbol* SYM_WALK_STELLA_TYPED_SYS;
extern Symbol* SYM_WALK_STELLA_SYS_INLINE_CALL;
extern Symbol* SYM_WALK_STELLA_SAFE_CAST;
extern Surrogate* SGT_WALK_STELLA_NON_OBJECT;
extern Surrogate* SGT_WALK_STELLA_WRAPPER;
extern Symbol* SYM_WALK_STELLA_LET;
extern Symbol* SYM_WALK_STELLA_VOID_SYS;
extern Symbol* SYM_WALK_STELLA_SLOT_TYPE_SPECIFIER;
extern Symbol* SYM_WALK_STELLA_SYS_FOREACH;
extern Symbol* SYM_WALK_STELLA_SETQ;
extern Symbol* SYM_WALK_STELLA_SETF;
extern Symbol* SYM_WALK_STELLA_SLOT_VALUE;
extern Symbol* SYM_WALK_STELLA_SLOT_VALUE_SETTER;
extern Symbol* SYM_WALK_STELLA_AREF;
extern Symbol* SYM_WALK_STELLA_AREF_SETTER;
extern Symbol* SYM_WALK_STELLA_WITH_PROCESS_LOCK;
extern Symbol* SYM_WALK_STELLA_LOOP;
extern Symbol* SYM_WALK_STELLA_VALUES;
extern Symbol* SYM_WALK_STELLA_SPECIAL;
extern Symbol* SYM_WALK_STELLA_SYS_SPECIAL;
extern Symbol* SYM_WALK_STELLA_RETURN;
extern Symbol* SYM_WALK_STELLA_MV_SETQ;
extern Symbol* SYM_WALK_STELLA_MV_BIND;
extern Symbol* SYM_WALK_STELLA_BREAK;
extern Symbol* SYM_WALK_STELLA_CONTINUE;
extern Symbol* SYM_WALK_STELLA_WHILE;
extern Symbol* SYM_WALK_STELLA_FOREACH;
extern Symbol* SYM_WALK_STELLA_FORALL;
extern Symbol* SYM_WALK_STELLA_SOME;
extern Symbol* SYM_WALK_STELLA_SETOF;
extern Symbol* SYM_WALK_STELLA_SET_OF;
extern Symbol* SYM_WALK_STELLA_SELECT;
extern Symbol* SYM_WALK_STELLA_IF;
extern Symbol* SYM_WALK_STELLA_UNLESS;
extern Symbol* SYM_WALK_STELLA_CHOOSE;
extern Symbol* SYM_WALK_STELLA_OR;
extern Symbol* SYM_WALK_STELLA_NOT;
extern Symbol* SYM_WALK_STELLA_COND;
extern Symbol* SYM_WALK_STELLA_CASE;
extern Symbol* SYM_WALK_STELLA_TYPECASE;
extern Symbol* SYM_WALK_STELLA_e;
extern Symbol* SYM_WALK_STELLA_i;
extern Symbol* SYM_WALK_STELLA__;
extern Symbol* SYM_WALK_STELLA_o;
extern Symbol* SYM_WALK_STELLA_s;
extern Symbol* SYM_WALK_STELLA_BQUOTE;
extern Symbol* SYM_WALK_STELLA_PRINT_STREAM;
extern Symbol* SYM_WALK_STELLA_PRINT_NATIVE_STREAM;
extern Symbol* SYM_WALK_STELLA_NEW;
extern Symbol* SYM_WALK_STELLA_ALLOCATE;
extern Symbol* SYM_WALK_STELLA_LOCAL_NEW;
extern Symbol* SYM_WALK_STELLA_MAKE;
extern Symbol* SYM_WALK_STELLA_FUNCALL;
extern Symbol* SYM_WALK_STELLA_SYS_CALL_FUNCTION_CODE;
extern Symbol* SYM_WALK_STELLA_SYS_CALL_METHOD_CODE;
extern Symbol* SYM_WALK_STELLA_THE_CODE;
extern Symbol* SYM_WALK_STELLA_SIGNAL_EXCEPTION;
extern Symbol* SYM_WALK_STELLA_EXCEPTION_CASE;
extern Symbol* SYM_WALK_STELLA_UNWIND_PROTECT;
extern Symbol* SYM_WALK_STELLA_SYS_UNWIND_PROTECT;
extern Symbol* SYM_WALK_STELLA_SYS_SLOT_VALUE;
extern Symbol* SYM_WALK_STELLA_SYS_SLOT_VALUE_SETTER;
extern Symbol* SYM_WALK_STELLA_SYS_CALL_METHOD_SETTER;
extern Symbol* SYM_WALK_STELLA_SYS_NEW;
extern Surrogate* SGT_WALK_STELLA_PROCESS_LOCK_OBJECT;
extern Keyword* KWD_WALK_PUBLICp;
extern Symbol* SYM_WALK_STELLA_TRUE;
extern Keyword* KWD_WALK_SYMBOLS;
extern Symbol* SYM_WALK_STELLA_INTERN_RIGID_SYMBOL_WRT_MODULE;
extern Symbol* SYM_WALK_STELLA_GET_STELLA_MODULE;
extern Symbol* SYM_WALK_STELLA_INTERN_SYMBOL_AT;
extern Symbol* SYM_WALK_STELLA_INTERN_SURROGATE_AT;
extern Symbol* SYM_WALK_STELLA_INTERN_KEYWORD_AT;
extern Symbol* SYM_WALK_STELLA_FALSE;
extern Symbol* SYM_WALK_STELLA_NIL;
extern Symbol* SYM_WALK_STELLA_NULL_INTEGER;
extern Symbol* SYM_WALK_STELLA_NULL_FLOAT;
extern Keyword* KWD_WALK_INLINE_ARGUMENT;
extern Surrogate* SGT_WALK_STELLA_KEYWORD;
extern Keyword* KWD_WALK_PLACE_WHERE_VRLET_WAS;
extern Keyword* KWD_WALK_PLACE_WHERE_LAST_EXPRESSION_WAS;
extern Keyword* KWD_WALK_DYNAMIC;
extern Symbol* SYM_WALK_STELLA_IT;
extern Symbol* SYM_WALK_STELLA_ON;
extern Symbol* SYM_WALK_STELLA_DYNAMIC_SLOTS;
extern Symbol* SYM_WALK_STELLA_KEY;
extern Symbol* SYM_WALK_STELLA_DO;
extern Symbol* SYM_WALK_STELLA_WRAPPEDVALUE;
extern Symbol* SYM_WALK_STELLA_VALUE;
extern Keyword* KWD_WALK_BIT;
extern Symbol* SYM_WALK_STELLA_DYNAMICSLOTS;
extern Symbol* SYM_WALK_STELLA_NEWVALUE;
extern Symbol* SYM_WALK_STELLA_FOUNDMATCHINGENTRYp;
extern Symbol* SYM_WALK_STELLA_THE_KV_LIST;
extern Symbol* SYM_WALK_STELLA_KV_CONS;
extern Symbol* SYM_WALK_STELLA_OLDVALUE;
extern Keyword* KWD_WALK_CONTEXT_SENSITIVEp;
extern Keyword* KWD_WALK_DONT_INHERITp;
extern Symbol* SYM_WALK_STELLA_ACCESS_IN_CONTEXT;
extern Symbol* SYM_WALK_STELLA_HOME_CONTEXT;
extern Keyword* KWD_WALK_COPY_TO_CHILDRENp;
extern Symbol* SYM_WALK_STELLA_UPDATE_IN_CONTEXT;
extern Symbol* SYM_WALK_STELLA_CS_VALUEp;
extern Surrogate* SGT_WALK_STELLA_ARRAY;
extern Symbol* SYM_WALK_STELLA_ANY_VALUE;
extern Symbol* SYM_WALK_STELLA_VARIABLE_DECLARATION;
extern Symbol* SYM_WALK_STELLA_ILLEGAL_VARIABLE;
extern Keyword* KWD_WALK_UNBIND_WITH_DESTRUCTORS;
extern Keyword* KWD_WALK_UNWIND_PROTECT;
extern Surrogate* SGT_WALK_STELLA_METHOD_SLOT;
extern Symbol* SYM_WALK_STELLA_OTHERWISE;
extern Symbol* SYM_WALK_STELLA_SYMBOL_ID;
extern Symbol* SYM_WALK_STELLA_GENERALIZED_SYMBOL;
extern Symbol* SYM_WALK_STELLA_BOOLEANp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_BOOLEANp;
extern Symbol* SYM_WALK_STELLA_INTEGERp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_INTEGERp;
extern Symbol* SYM_WALK_STELLA_FLOATp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_FLOATp;
extern Symbol* SYM_WALK_STELLA_STRINGp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_STRINGp;
extern Symbol* SYM_WALK_STELLA_CHARACTERp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_CHARACTERp;
extern Symbol* SYM_WALK_STELLA_WRAPPERp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_WRAPPERp;
extern Surrogate* SGT_WALK_STELLA_VERBATIM_STRING_WRAPPER;
extern Symbol* SYM_WALK_STELLA_VERBATIM_STRINGp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_VERBATIM_STRINGp;
extern Symbol* SYM_WALK_STELLA_SURROGATEp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_SURROGATEp;
extern Surrogate* SGT_WALK_STELLA_TYPE;
extern Symbol* SYM_WALK_STELLA_TYPEp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_TYPEp;
extern Symbol* SYM_WALK_STELLA_SYMBOLp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_SYMBOLp;
extern Surrogate* SGT_WALK_STELLA_TRANSIENT_SYMBOL;
extern Symbol* SYM_WALK_STELLA_TRANSIENT_SYMBOLp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_TRANSIENT_SYMBOLp;
extern Symbol* SYM_WALK_STELLA_KEYWORDp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_KEYWORDp;
extern Symbol* SYM_WALK_STELLA_CONSp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_CONSp;
extern Symbol* SYM_WALK_STELLA_STELLA_CLASSp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_CLASSp;
extern Surrogate* SGT_WALK_STELLA_STORAGE_SLOT;
extern Symbol* SYM_WALK_STELLA_STORAGE_SLOTp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_STORAGE_SLOTp;
extern Symbol* SYM_WALK_STELLA_METHOD_SLOTp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_METHOD_SLOTp;
extern Surrogate* SGT_WALK_STELLA_ANCHORED_TYPE_SPECIFIER;
extern Symbol* SYM_WALK_STELLA_ANCHORED_TYPE_SPECIFIERp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_ANCHORED_TYPE_SPECIFIERp;
extern Surrogate* SGT_WALK_STELLA_PARAMETRIC_TYPE_SPECIFIER;
extern Symbol* SYM_WALK_STELLA_PARAMETRIC_TYPE_SPECIFIERp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OF_PARAMETRIC_TYPE_SPECIFIERp;
extern Symbol* SYM_WALK_STELLA_ISAp;
extern Symbol* SYM_WALK_STELLA_SUBTYPE_OFp;
extern Surrogate* SGT_WALK_STELLA_GENERALIZED_SYMBOL;
extern Symbol* SYM_WALK_STELLA_STRING_EQLp;
extern Symbol* SYM_WALK_STELLA_SAFE_PRIMARY_TYPE;
extern Surrogate* SGT_WALK_STELLA_STANDARD_OBJECT;
extern Surrogate* SGT_WALK_STELLA_LITERAL;
extern Symbol* SYM_WALK_STELLA_EQL_TO_BOOLEANp;
extern Symbol* SYM_WALK_STELLA_EQL_TO_INTEGERp;
extern Symbol* SYM_WALK_STELLA_EQL_TO_FLOATp;
extern Symbol* SYM_WALK_STELLA_EQL_TO_STRINGp;
extern Symbol* SYM_WALK_STELLA_GET_QUOTED_TREE;
extern Symbol* SYM_WALK_STELLA_METHOD_BODY_ARGUMENTp;
extern Keyword* KWD_WALK_WARN;
extern Keyword* KWD_WALK_ERROR;
extern Keyword* KWD_WALK_CONTINUABLE_ERROR;
extern Symbol* SYM_WALK_STELLA_CONCATENATE;
extern Symbol* SYM_WALK_STELLA_WRAP_BOOLEAN;
extern Symbol* SYM_WALK_STELLA_CONS;
extern Symbol* SYM_WALK_STELLA_CONS_LIST;
extern Symbol* SYM_WALK_STELLA_ALLOCATE_ITERATOR;
extern Surrogate* SGT_WALK_STELLA_ARGUMENT_LIST_ITERATOR;
extern Symbol* SYM_WALK_STELLA_LENGTH;
extern Symbol* SYM_WALK_STELLA_METHOD_VARIABLE_ARGUMENTSp;
extern Symbol* SYM_WALK_STELLA_GET_SYM;
extern Symbol* SYM_WALK_STELLA_GET_SGT;
extern Symbol* SYM_WALK_STELLA_GET_KWD;
extern Surrogate* SGT_WALK_STELLA_ARGUMENT_LIST;
extern Symbol* SYM_WALK_STELLA_CACHED_INLINABLE_METHOD_BODY;
extern Keyword* KWD_WALK_INLINE_REFERENCES;
extern Symbol* SYM_WALK_STELLA_INLINE_CALL;
extern Symbol* SYM_WALK_STELLA_METHOD_INHERITS_THROUGH;
extern Keyword* KWD_WALK_FUNCTION;
extern Symbol* SYM_WALK_STELLA_FORWARD_DECLARATIONp;
extern Symbol* SYM_WALK_STELLA_METHOD_NATIVEp;
extern Symbol* SYM_WALK_STELLA_METHOD_COMMANDp;
extern Symbol* SYM_WALK_STELLA_MAIN;
extern Keyword* KWD_WALK_METHODS;
extern Keyword* KWD_WALK_CLASS;
extern Keyword* KWD_WALK_EMBEDDED;
extern Symbol* SYM_WALK_STELLA_CLASS_CONSTRUCTOR_CODE;
extern Symbol* SYM_WALK_STELLA_CLASS_AUXILIARY_METHODS;
extern Symbol* SYM_WALK_STELLA_AUXILIARY_METHOD_REASON;
extern Keyword* KWD_WALK_FIRST_CLASS_WITH_TYPECASE;
extern Keyword* KWD_WALK_AUXILIARYp;
extern Symbol* SYM_WALK_STELLA_PRINT_FORM;
extern Symbol* SYM_WALK_STELLA_PRINT_OBJECT;
extern Symbol* SYM_WALK_STELLA_SELF;
extern Symbol* SYM_WALK_STELLA_STREAM;
extern Symbol* SYM_WALK_STELLA_NATIVE_OUTPUT_STREAM;
extern Symbol* SYM_WALK_STELLA_STRINGIFY;
extern Keyword* KWD_WALK_CLASSES;
extern Keyword* KWD_WALK_FINALIZE_CLASSES;
extern Symbol* SYM_WALK_STELLA_FINALIZE_CLASSES;
extern Keyword* KWD_WALK_FINALIZE_METHODS;
extern Symbol* SYM_WALK_STELLA_FINALIZE_SLOTS;
extern Symbol* SYM_WALK_STELLA_CLEANUP_UNFINALIZED_CLASSES;
extern Symbol* SYM_WALK_STELLA_DEFINE_EXTERNAL_SLOT_FROM_STRINGIFIED_SOURCE;
extern Symbol* SYM_WALK_STELLA_OBJECT;
extern Symbol* SYM_WALK_STELLA_METHOD_LISP_MACROp;
extern Symbol* SYM_WALK_STELLA_STORE_MACRO;
extern Keyword* KWD_WALK_UNBOUND_SPECIAL_VARIABLE;
extern Keyword* KWD_WALK_GLOBALS;
extern Symbol* SYM_WALK_STELLA_DEFINE_STELLA_GLOBAL_VARIABLE_FROM_STRINGIFIED_SOURCE;
extern Symbol* SYM_WALK_STELLA_DEFINE_STELLA_TYPE_FROM_STRINGIFIED_SOURCE;
extern Keyword* KWD_WALK_FINAL;
extern Symbol* SYM_WALK_STELLA_CURRENT_STARTUP_TIME_PHASEp;
extern Keyword* KWD_WALK_MODULES;
extern Symbol* SYM_WALK_STELLA_WITHIN_MODULE;
extern Symbol* SYM_WALK_STELLA_oSTELLA_MODULEo;
extern Symbol* SYM_WALK_STELLA_oSTARTUP_TIME_PHASEo;
extern Symbol* SYM_WALK_STELLA_METHOD_STARTUP_CLASSNAME;
extern Symbol* SYM_WALK_STELLA_FUNCTION;
extern Symbol* SYM_WALK_STELLA_LOOKUP_FUNCTION;
extern Symbol* SYM_WALK_STELLA_SYS_SIGNAL;
extern Surrogate* SGT_WALK_STELLA_STELLA_ROOT_EXCEPTION;
extern Symbol* SYM_WALK_STELLA_SYS_HANDLER_CASE;
extern Surrogate* SGT_WALK_STELLA_NATIVE_EXCEPTION;
extern Symbol* SYM_WALK_STELLA_SYS_HANDLE_EXCEPTION;
extern Keyword* KWD_WALK_OTHERWISE;
extern Symbol* SYM_WALK_STELLA_INITIAL_ELEMENT;
extern Symbol* SYM_WALK_STELLA_SIZE;
extern Symbol* SYM_WALK_STELLA_STORAGE_SLOT;
extern Surrogate* SGT_WALK_STELLA_CODE;
extern Keyword* KWD_WALK_METHOD;
extern Symbol* SYM_WALK_STELLA_METHOD_CODE;
extern Surrogate* SGT_WALK_STELLA_COMPOUND_TYPE_SPECIFIER;
extern Symbol* SYM_WALK_STELLA_DOCUMENTATION;
extern Symbol* SYM_WALK_STELLA_EXPRESSION;
extern Symbol* SYM_WALK_STELLA_IGNORE;
extern Symbol* SYM_WALK_STELLA_oIGNORETRANSLATIONERRORSpo;
extern Symbol* SYM_WALK_STELLA_CL_INCREMENTALLY_TRANSLATE;
extern Symbol* SYM_WALK_STELLA_REGISTER_NATIVE_NAME;
extern Symbol* SYM_WALK_STELLA_REST;
extern Symbol* SYM_WALK_STELLA_NTH_REST;
extern Symbol* SYM_WALK_STELLA_NTH;
extern Symbol* SYM_WALK_STELLA_ARGUMENTS;
extern Symbol* SYM_WALK_STELLA_RESULT;
extern Symbol* SYM_WALK_STELLA_METHOD_EVALUATE_ARGUMENTSp;
extern Symbol* SYM_WALK_STELLA_EVALUATOR_WRAPPER_CODE;
extern Symbol* SYM_WALK_STELLA_STARTUP_WALK;


} // end of namespace stella
